#include <windows.h>
#include <alchemw.h>
#include "resource.h"

#define SHOWDIALOG 0
#define CLOSEDIALOG 1
#define QUIT 2

typedef struct tagDataStruct {
	char szName[61];
} DATASTRUCT;

int WINAPI _export LibMain(HINSTANCE,WORD,WORD,LPSTR);
int WINAPI	_export WEP (int);
WORD WINAPI	_export PlugType(LPSLOT,LPSTR);
WORD WINAPI	_export PlugProcess(LPSLOT);
void WINAPI _export PlugDestroy(LPSLOT);
BOOL WINAPI	_export PlugUnique(LPSLOT,LPCSTR,LPSTR);
WORD WINAPI	_export PlugDialog(LPSLOT,WORD);
WORD WINAPI	_export PlugButton(LPSLOT,WORD);
BOOL WINAPI	_export PlugData(LPSLOT,BOOL,void *);
BOOL WINAPI	_export PlugMouse(LPSLOT,BYTE,WORD,WORD);
void WINAPI	_export PlugActivate(LPSLOT,BOOL);
void WINAPI	_export PlugPaint(LPSLOT,HDC,BOOL,RECT *);
void WINAPI	_export PlugResize(LPSLOT,WORD,WORD);

HINSTANCE hInstance;

#pragma argsused
int WINAPI _export LibMain(HINSTANCE hInst,WORD wDataSegment,WORD wHeapSize,LPSTR lpszCmdLine ) {
	hInstance = hInst;
	return TRUE;
}
#pragma argsused
int WINAPI _export WEP(int bSystemExit) {
	return 1;
}
#pragma argsused
void WINAPI	_export PlugActivate(LPSLOT hSlot,BOOL activate) {
	return;
}
#pragma argsused
void WINAPI	_export PlugPaint(LPSLOT hSlot,HDC dc,BOOL erase,RECT *rect){
	return;
}
#pragma argsused
void WINAPI _export PlugResize(LPSLOT hSlot,WORD width,WORD height) {
	return;
}
#pragma argsused
void WINAPI _export PlugDestroy( LPSLOT hSlot ) {

	AlLogWrite(hSlot,"Leaving JDS CSPDLG1");
	AlFree( hSlot );
}
#pragma argsused
BOOL WINAPI _export PlugUnique(LPSLOT hSlot,LPCSTR args,LPSTR message) {
	return TRUE;
}
#pragma argsused
WORD WINAPI _export PlugDialog(LPSLOT hSlot,WORD result) {

	WORD State;
	DATASTRUCT* ds;
	WORD nRetVal;

	State = AlGetState(hSlot);
	nRetVal = AL_IDLE;
	switch (State) {
		case SHOWDIALOG:
			ds = (DATASTRUCT*) AlLock(hSlot);
			if (result == IDOK) {
				AlGetText(hSlot,IDC_EDIT1,ds->szName,60);
				AlSetState(hSlot,CLOSEDIALOG);
			}
			else
				AlSetState(hSlot,QUIT);
			AlUnlock(hSlot);
			nRetVal = AL_OK;
		break;
		case CLOSEDIALOG:
			AlSetState(hSlot,QUIT);
			nRetVal = AL_OK;
		break;
	}
	return nRetVal;
}
#pragma argsused
WORD WINAPI _export PlugButton(LPSLOT hSlot,WORD id) {
	return AL_IDLE;
}
#pragma argsused
BOOL WINAPI _export PlugMouse(LPSLOT hSlot,BYTE code,WORD x,WORD y) {
	AlMouseRelease(hSlot);
	return AL_IDLE;
}
#pragma argsused
WORD WINAPI _export PlugType(LPSLOT hSlot,LPSTR title) {

	AlLogWrite(hSlot,"Entering JDS CSPDLG1");
	AlCaption(hSlot,"Plug-In: JDS CSPDLG1");
	AlAlloc(hSlot,61);
	AlSetState(hSlot,SHOWDIALOG);
	AlUnlock(hSlot);
	return AL_WIN_HIDDEN;
}
#pragma argsused
WORD WINAPI _export PlugProcess(LPSLOT hSlot) {

	WORD nState;
	DATASTRUCT* ds;
	WORD nRetVal;

	nState = AlGetState(hSlot);
	nRetVal = AL_IDLE;
	switch (nState) {
		case SHOWDIALOG:
			AlLoadDialog(hSlot,MAKEINTRESOURCE(IDD_DIALOG1),hInstance);
			AlLimitText(hSlot,IDC_EDIT1,60);
			AlExecDialog(hSlot);
			nRetVal = AL_IDLE;
		break;
		case CLOSEDIALOG:
			AlLoadDialog(hSlot,MAKEINTRESOURCE(IDD_DIALOG2),hInstance);
			ds = (DATASTRUCT*) AlLock(hSlot);
			AlSetString(hSlot,IDC_STATIC_1,ds->szName);
			AlUnlock(hSlot);
			AlExecDialog(hSlot);
			nRetVal = AL_IDLE;
		break;
		case QUIT:
			nRetVal = AL_DIE;
		break;
	}
	return nRetVal;
}

#pragma argsused
BOOL WINAPI _export PlugData(LPSLOT hSlot,BOOL more,void *data) {
	return more;
}


